unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ComCtrls, ExtCtrls, ActnList, StdCtrls, Grids, DBGrids;

type
  TFMain = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    sbStop: TSpeedButton;
    ActionList1: TActionList;
    ActionClose: TAction;
    Label1: TLabel;
    Shape: TShape;
    sbRun: TSpeedButton;
    ActionRun: TAction;
    sbProcedura: TSpeedButton;
    ActionUruchomProc: TAction;
    procedure ActionCloseExecute(Sender: TObject);
    procedure ActionRunExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ActionUruchomProcExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FMain: TFMain;

implementation

uses DataModule, FormOsoby, DData;
{$R *.dfm}

procedure TFMain.ActionCloseExecute(Sender: TObject);
begin
   Close();
end;

procedure TFMain.FormActivate(Sender: TObject);
begin
   if DM.Database.Connected = True then begin
      Shape.Brush.Color := clGreen;
   end
   else begin
      Shape.Brush.Color := clRed;
   end;
end;

procedure TFMain.ActionRunExecute(Sender: TObject);
var
   ret : Boolean;
   
begin
   ret := Assigned(FOsoby);

   if not ret then begin
      FOsoby := TFOsoby.Create(Application);
      FOsoby.Show();
   end
   else begin
      FOsoby.Show();
   end;
end;

procedure TFMain.ActionUruchomProcExecute(Sender: TObject);
var
   dataur  : TDateTime;
   res     : TMOdalResult;
   ilosc   : Integer;

begin
   DlgData := TDlgData.Create(Self);
   Res     := DlgData.ShowModal();

   if Res = mrOK then begin
      dataur := DlgData.dtpData.Date;

      with DM.P_CZYTELNICY do begin
         ParamByName('DATAUR').AsDateTime := dataur;

         ExecProc();

         ilosc := ParamByName('WYNIK').AsInteger;
         
         ShowMessage('Data ur. ' + DateToStr(dataur) + #10#13 +
                     'Ilo osb urodzonych po tym dniu: ' + IntToStr(ilosc));
      end;
   end;
end;

end.

